﻿# -*- coding: utf-8 -*-
import xbmcplugin, xbmcgui
try:
	from urllib2 import urlopen, Request
except ImportError:
	from urllib.request import urlopen, Request
try:
	from urllib import urlencode
except ImportError:
	from urllib.parse import urlencode
try:
	from urlparse import urlparse, parse_qs
except ImportError:
	from urllib.parse import urlparse, parse_qs
import json, re, time
from collections import OrderedDict

def httpget(url):
	try:
		request = Request(
			url,
			headers = {
				'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36'
			})
		return urlopen(request).read().decode('utf-8')
	except:
		return False

def item(title, para, isFolder = True):
	listitem = xbmcgui.ListItem(title)
	xbmcplugin.addDirectoryItem(handle, sys.argv[0] + '?' + urlencode(para), listitem, isFolder)

def play(title, url):
	listitem = xbmcgui.ListItem(title)
	xbmc.Player().play(url, listitem)

handle = int(sys.argv[1])
url = sys.argv[2]
if not url:
	url = 'http://www.huaren.tv/sports'
	content = httpget(url)
	if not content:
		xbmcgui.Dialog().ok('错误', '错误代码: huarentv 000')
		sys.exit(0)
	content = re.search('var\s+pageInfo\s*=\s*(.*?);', content)
	if not content:
		xbmcgui.Dialog().ok('错误', '错误代码: huarentv 001')
		sys.exit(0)
	content = content.group(1)
	try:
		data = json.loads(content, object_pairs_hook = OrderedDict)
	except:
		xbmcgui.Dialog().ok('错误', '错误代码: huarentv 002')
		sys.exit(0)
	try:
		data = data['live_enter']['0']
	except:
		xbmcgui.Dialog().ok('错误', '错误代码: huarentv 003')
		sys.exit(0)
	for e in data:
		title = ''
		if 'time' in e:
			title += time.strftime('%d %H:%M', time.localtime(e['time'])) + ' '
		if 'cate' in e:
			title += e['cate']
		if 'team' in e:
			for e1 in e['team']:
				title += ' ' + e1
		#title = e['title']
		#st = time.strftime('%H:%M', time.localtime(e['start_time']))
		#et = time.strftime('%H:%M', time.localtime(e['end_time']))
		#title = '%s - %s %s' % (st, et, title)
		item(title, {'title': title.encode('utf-8'), 'id': e['url']}, False)
	xbmcplugin.endOfDirectory(handle)
else:
	o = urlparse(url)
	q = parse_qs(o.query)
	if 'id' in q:
		id = q['id'][0]
		url = 'http://www.huaren.tv' + id
		content = httpget(url)
		if not content:
			xbmcgui.Dialog().ok('错误', '错误代码: huarentv 010')
			sys.exit(0)
		content = re.search('window.currentPartInfo\s*=\s*(.*?);', content)
		if not content:
			xbmcgui.Dialog().ok('错误', '错误代码: huarentv 011')
			sys.exit(0)
		content = content.group(1)
		try:
			data = json.loads(content, object_pairs_hook = OrderedDict)
		except:
			xbmcgui.Dialog().ok('错误', '错误代码: huarentv 012')
			sys.exit(0)
		if 'playUrl' not in data:
			xbmcgui.Dialog().ok('错误', '错误代码: huarentv 013')
			sys.exit(0)
		play(q['title'][0], data['playUrl'])
